
//isdnraw stuff


#ifndef __ISDN_RAWIF_H__
#define __ISDN_RAWIF_H__


/* the following definitions and structures belong to the /dev/isdnraw
 * character device
 */

/* packet types */
#define ISDNRAW_PACKET_CMD	0
#define ISDNRAW_PACKET_DATA	1

/* dsp flags */
#define ISDNRAW_DSP_ALAW_DTMF	1L	  /* dtmf decoding */
#define ISDNRAW_DSP_ULAW_DTMF	(1L << 1) /* dtmf decoding */
#define ISDNRAW_DSP_ALAW_PULSE	(1L << 2) /* pulse dialing decoding */
#define ISDNRAW_DSP_ULAW_PULSE	(1L << 3) /* pulse dialing decoding */
#define ISDNRAW_DSP_CONVERSION	(1L << 4) /* do conversion */

/* conversion type: ALAW_ULAW means: phone line is alaw, application is ulaw */
#define ISDNRAW_CONV_NONE	 0
#define	ISDNRAW_CONV_ULAW_ALAW	 1
#define	ISDNRAW_CONV_ULAW_ADPCM2 2
#define	ISDNRAW_CONV_ULAW_ADPCM3 3
#define	ISDNRAW_CONV_ULAW_ADPCM4 5
#define	ISDNRAW_CONV_ALAW_ULAW   6
#define	ISDNRAW_CONV_ALAW_ADPCM2 7
#define	ISDNRAW_CONV_ALAW_ADPCM3 8
#define	ISDNRAW_CONV_ALAW_ADPCM4 9

/* ioctl */
#define IRIOCSOUTF	SIOCDEVPRIVATE
#define IRIOCGOUTF	(SIOCDEVPRIVATE + 1)
#define IRIOCSINF	(SIOCDEVPRIVATE + 2)
#define IRIOCGINF	(SIOCDEVPRIVATE + 3)
#define IRIOCSDSP	(SIOCDEVPRIVATE + 4)
#define IRIOCGDSP	(SIOCDEVPRIVATE + 5)
#define IRIOCSCONV	(SIOCDEVPRIVATE + 6)
#define IRIOCGCONV	(SIOCDEVPRIVATE + 7)
#define IRIOCBIND	(SIOCDEVPRIVATE + 8) /* get channel (before dialing) */
#define IRIOCUNBIND	(SIOCDEVPRIVATE + 9) /* release channel */

/* incomming filter */
typedef struct isdnraw_infilter {
  int			accept;		 /* accept incomming calls. NOTE: if this is 0, no call will be accepted anyway */
  char			cpn[32];	 /* accept only given cpn */
  char			msn[32];	 /* accept only given msn */
  int			si1;	 	 /* 0 to accept any */
  int			si2;	 	 /* 0 to accept any */
  int   		signalmode;    	 /* accept in signal mode */
  int   		icallw;   	 /* accept also waiting calls */
  char			drvid[25];	 /* when calling only use driver */
  int			l2_proto;	
  int			l3_proto;	
} isdnraw_infilter;


/* outgoing filter */
typedef struct isdnraw_outfilter {
  char			drvid[25];	 /* when calling only use driver */
  char			cpn[32];	 /* use given cpn */
  int   		signalmode;     	 /* calls in signal mode */
  int			usage;	         /* usage on outgoing calls */
  int			l2_proto;	
  int			l3_proto;	
} isdnraw_outfilter;


#endif /* __ISDN_RAWIF_H__ */
